#include <iostream>
#include <fstream>
#include <cstdlib>
#include <set>
using namespace std;

#define done(r, m) (cout << r << '\n', cerr << m << '\n', exit(0))

void read_set(istream & is, set<int> & s) {
	int n;
	is >> n;
	for ( ; n > 0; --n) {
		int t;
		is >> t;
		s.insert(t);
	}
}

int main(int argc, const char *argv[]) {
	if (argc != 4) {
		done(0, "Usage: " << argv[0] << " input hint output");
	}

	//ifstream in(argv[1]);
	ifstream hint(argv[2]);
	ifstream out(argv[3]);

	int k_hint;
	hint >> k_hint;

	if (k_hint == 0) {
		int k_out;
		out >> k_out;
		if (!out or k_out != 0) done(0, "Wrong answer");
		char c;
		if (out >> c) done(0, "Wrong answer");
		done(1, "OK");
	} else {
		int a_out, b_out;
		out >> a_out >> b_out;
		if (!out or a_out == b_out) done(0, "Wrong answer");
		char c;
		if (out >> c) done(0, "Wrong answer");
		for ( ; k_hint > 0; --k_hint) {
			set<int> s1, s2;
			read_set(hint, s1);
			read_set(hint, s2);
			if (s1.contains(a_out) and s2.contains(b_out)) done(1, "OK");
			if (s1.contains(b_out) and s2.contains(a_out)) done(1, "OK");
		}
		done(0, "Wrong answer");
	}
}
