// simple generator -- every person likes a randomly chosen interval
// every interval is duplicated

#include <cstdint>
#include "testlib.h"
#include <iostream>

using namespace std;

int main (int argc, char **argv) {
  registerGen(argc, argv, 1);

  int n = opt<int>("n");
  int m = opt<int>("m");
  cout << 2 * n << " " << m << '\n';

  for (int i = 0; i < n; i++) {
    int L = rnd.next(1, m);
    int R = rnd.next(1, m);

    if (L > R)
      swap(L, R);

    cout << L << " " << R << '\n';
    cout << L << " " << R << '\n';
  }
}
