#include <iostream>
#include <cstring>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <cmath>

using namespace std;
typedef long long ll;
const int N = 2e5+9,M = 998244353,inf = 0x3f3f3f3f;

struct Node
{
    int l,r;
    int id;
};

bool cmp1(Node &x,Node &y){
    return x.l == y.l ? x.r > y.r : x.l < y.l;
}

bool cmp2(Node &x,Node &y){
    return x.r == y.r ? x.l < y.l : x.r > y.r;
}

void solve()
{
  int n,_;
  cin>>n>>_;
    set<int> s;
    vector<int> ans(n);
    vector<Node> a;

    for(int i=0,x,y;i<n;++i){
        cin>>x>>y;
        a.push_back({x,y,i});
    }

    s.insert(1e9+1);
    sort(a.begin(),a.end(),cmp1);

    for(int i=0;i<(int)a.size();++i){
        int r = a[i].r,id = a[i].id;
        auto it = lower_bound(s.begin(),s.end(),r);
        if((*it)!=1e9+1) ans[id] += (*it) - r;
        s.insert(r);
    }

    s.clear();
    s.insert(0);
    sort(a.begin(),a.end(),cmp2);
    for(int i=0;i<n;++i){
        int l = a[i].l,id = a[i].id;
        auto it = upper_bound(s.begin(),s.end(),l);
        --it;
        if(it!=s.begin()) ans[id] += l - (*it);
        s.insert(l);
    }

    map<pair<int,int>,int> mp;
    for(int i=0;i<n;++i){
        int l = a[i].l, r = a[i].r;
        mp[{l,r}] ++;
    }

    for(int i=0;i<n;++i){
        int l = a[i].l, r = a[i].r,id = a[i].id;
        if(mp[{l,r}]>1) ans[id] = 0;
    }

    for(int i=0;i<n;++i) cout<< ans[i]<< '\n';
}

int main()
{
    ios::sync_with_stdio(false),cin.tie(0),cout.tie(0);
    //fflush(stdout);

    int t=1;
    while(t--) solve();

    return 0;
}
