# Python's set does not have a lower-bound method
# So, we use a linear search over a list instead
# This is too slow for larger test cases, however
def lbound(v, s):
    r = None
    for x in s:
        if x >= v:
            if r == None or r > x:
                r = x
    return r

n, m = (int(x) for x in input().split())

seg = []
for _ in range(n):
    seg.append(tuple(int(x) for x in input().split()))

ans = [0 for _ in range(n)]

for _ in range(2):
    ord = [i for i in range(n)]
    ord.sort(key = lambda i : (seg[i][0], -seg[i][1]))

    bounds = []
    for i in ord:
        lb = lbound(seg[i][1], bounds)
        if lb != None:
            ans[i] += lb - seg[i][1]
        if lb != seg[i][1]: # Avoid adding duplicates
            bounds.append(seg[i][1])

    for i in range(n):
        l, r = seg[i]
        seg[i] = (m - r + 1, m - l + 1)

cnt = {}
for s in seg:
    cnt[s] = cnt.get(s, 0) + 1
for i in range(n):
    if cnt[seg[i]] > 1:
        ans[i] = 0

for a in ans:
    print(a)
