#include <bits/stdc++.h>
using namespace std;
typedef long long ll; typedef pair<ll, ll> pll;
#define REP(i, n) for(int i = 1; i <= (n); i++)
#define testcases \
  int test_amount;        \
  cin >> test_amount;       \
  while (test_amount--)
const ll inf = 1e18; const ll maxr = 1e2;

ll n, seg[800003][2], ans[200003], mxans, mnans, updl, updr, templ, tempr;
map<pll, ll> sm;

struct node {
	node* l = nullptr; node* r = nullptr;
	ll mn = inf;
	ll mx = 0;
};
vector<pair<pll, ll>> sweep;

node* root;

bool cpr(pair<pll, ll> x, pair<pll, ll> y) {
	if (x.first.first < y.first.first) return 1;
	else if (x.first.first > y.first.first) return 0;
	return (x.first.second > y.first.second);
}

void update(node* p, ll l, ll r, ll ql, ll qr) {
	if (l > qr || r < ql) {return;}
	if (l >= ql && r <= qr) {
		p->mx = max(p->mx, updl); p->mn = min(p->mn, updr);
		//cout << "updating " << l << "-" << r << " with " << p->mx << " " << p->mn << "\n";
		return;
	}
	
	ll mid = (l+r)/2;
	if (p->l == nullptr) p->l = new node();
	update(p->l, l, mid, ql, qr);
	if (p->r == nullptr) p->r = new node();
	update(p->r, mid+1, r, ql, qr);
}

void query(node *p, ll l, ll r, ll q) {
	//cout << "testing " << l << " " << r << "\n";
	if (l > q || r < q) return;
	
	//cout << l << "-" << r << " there is " << p->mx << " and " << p->mn << "\n";
	
	templ = max(templ, p->mx);
	tempr = min(tempr, p->mn);
	
	if (l == q && r == q) return;
	
	ll mid = (l+r)/2;
	if (p->l == nullptr) p->l = new node();
	query(p->l, l, mid, q);
	if (p->r == nullptr) p->r = new node();
	query(p->r, mid+1, r, q);
}

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0); cout.tie(0);

  int _;
  cin >> n >> _;
  	sm.clear();
  	root = new node(); ll l, r; sweep.clear();
  	REP(i, n) {cin >> l >> r; sweep.push_back({{l, r}, i}); sm[{l, r}]++;}
  	sort(sweep.begin(), sweep.end(), cpr);
  	
  	for (auto i : sweep) {
  		updl = i.first.first; updr = i.first.second; 
  		
  		//cout << "got " << updl << " " << updr << "\n";
  		
		templ = 0; tempr = inf; 
		query(root, 1, maxr, updr);
		
		//cout << templ << " to " << tempr << "\n";
		
		ans[i.second] = templ ? tempr-templ+1-(updr-updl+1) : 0;
		if (sm[{updl, updr}] > 1) ans[i.second] = 0;
		
		update(root, 1, maxr, updl, updr);
	}
	
  	REP(i, n) cout << ans[i] << "\n";

  return 0;
}


