#include <cstdint>
#include "testlib.h"

using namespace std;

int main (int argc, char **argv) {
  registerGen(argc, argv, 1);

  int n = opt<int>("n");
  int m = opt<int>("m");

  cout << n << " " << m << '\n';

  vector<pair<int, int>> intervals;
  int l = 1, r = m;
  for (int i = 0; i < n; i++) {
    ensure(l <= r);
    intervals.emplace_back(l, r);
    l++;
    r--;
  }

  shuffle(intervals.begin(), intervals.end());
  for (int i = 0; i < n; i++)
    cout << intervals[i].first << " " << intervals[i].second << '\n';
}
