// random WA from codeforces
// only problem is array limits
//chockolateman

#include<bits/stdc++.h>

using namespace std;

long long T,N,_,left_lim[200005],right_lim[20005];
pair<pair<long long,long long>,long long> users[200005]; // {{left,right},user};
bool problem[200005];

int main()
{
  T=1;
    while(T--)
    {
      scanf("%lld%lld",&N,&_);
        for(long long l,r,i = 1 ; i <= N ; i++)
        {
            scanf("%lld%lld",&l,&r);
            users[i] = {{l,-r},i};
            left_lim[i] = -1;
            right_lim[i] = -1;
            problem[i] = false;
        }
        sort(users+1,users+N+1);

        //Step 1: Avoid doubles
        for(long long i = 2 ; i <= N ; i++)
            if(users[i].first == users[i-1].first)
            {
                problem[users[i].second] = true;
                problem[users[i-1].second] = true;
            }
        
        //Find the closest to the left that ends after you
        stack<pair<long long,long long>> order;
        for(int i = 1 ; i <= N ; i++)
        {
            int l = users[i].first.first;
            int r = -users[i].first.second;
            int x = users[i].second;
            while(!order.empty() && order.top().first < r)
                order.pop();
            if(order.empty())
                problem[x] = true;
            else
                left_lim[x] = l - order.top().second;
            order.push({r,l}); 
        }
        while(!order.empty())
            order.pop();
        
        for(int i = 1 ; i <= N ; i++)
        {
            users[i].first.first *= -1;
            users[i].first.second *= -1;
            swap(users[i].first.first,users[i].first.second);
        }
        sort(users+1,users+N+1);
        for(int i = N ; i >= 1 ; i--)
        {
            int l = -users[i].first.second;
            int r = users[i].first.first;
            int x = users[i].second;
            while(!order.empty() && order.top().first > l)
                order.pop();
            if(order.empty())
                problem[x] = true;
            else
                right_lim[x] = order.top().second - r;
            order.push({l,r});
        }
        while(!order.empty())
            order.pop();
        for(int i = 1 ; i <= N ; i++)
        {
            if(problem[i])
                printf("0\n");
            else
                printf("%lld\n",left_lim[i] + right_lim[i]);
        }
    }
    return 0;
}
