// random WA solution from CF

#include "bits/stdc++.h"
#define int long long
#define ull unsigned long long
#define PII pair<int, int>
#define TIII tuple<int, int, int>
#define LL __int128
#define eps 1e-6
using namespace std;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
//998244353 212370440130137957ll
constexpr int N = 2e6 + 10, M = 2e6 + 10, mod = 1e9 + 7, inf = 1e18;
struct Fenwick
{
    int n;
    vector<int> a;

    Fenwick(int _n)
    {
        n = _n;
        vector<int>(n + 1).swap(a);
    }

    void add(int x, int v)
    {
        for (int i = n - x + 1; i <= n; i += i & -i) a[i] = max(a[i], v);
    }

    int query(int x)
    {
        int ans = 0;
        for (int i = n - x + 1; i; i -= i & -i) ans = max(ans, a[i]);
        return ans;
    }
};
int n, m;

void solve()
{
  int _;
  cin >> n >> _;
    vector<TIII > op;
    map<PII, int> cnt;
    vector<int> RX(1);
    for (int i = 1; i <= n; i++)
    {
        int l, r;
        cin >> l >> r;
        op.emplace_back(l, r, i);
        RX.emplace_back(r);
        cnt[PII(l, r)]++;
    }
    std::sort(RX.begin() + 1, RX.end());
    RX.erase(unique(RX.begin() + 1, RX.end()), RX.end());
    std::sort(op.begin(), op.end(), [&](TIII a, TIII b)
    {
        return get<0>(a) == get<0>(b) ? get<1>(a) > get<1>(b) : get<0>(a) < get<0>(b);
    });
    vector<int> ans(n + 1);
    set<int> s;
    Fenwick bit(n);
    for (int i = 0; i < op.size(); i++)
    {
        int l, r, id;
        tie(l, r, id) = op[i];
        int R = 0, L = 0;
        auto it = s.lower_bound(r);
        if (it != s.end()) R = *it;
        int pos = std::lower_bound(RX.begin(), RX.end(), r) - RX.begin();
        L = bit.query(pos);
        if (L and R)
            ans[id] = R - L - (r - l);
        s.emplace(r), bit.add(pos, l);
    }
    for (int i = 1; i <= n; i++)
    {
        int l, r, id;
        tie(l, r, id) = op[i];
        if (cnt[PII(l, r)] > 1) cout << 0 << endl;
        else
        {
            cout << ans[i] << endl;
        }
    }
}

signed main()
{
    std::ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    cout << fixed << setprecision(2);

#ifndef ONLINE_JUDGE
    freopen("in.txt", "rt", stdin);
    freopen("out.txt", "wt", stdout);
#endif

    int Cases = 1;
    while (Cases--)
    {
        solve();
    }
    return 0;
}
