#!/usr/bin/env python3

# Input validator

import sys

st = {2, 3, 4, 5, 6, 7}

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n, m, q = (int(x) for x in fi.readline().split())
if 2 > n or n > 1e18:
    sys.exit('N out of range')
if 1 > m or m > 1e5:
    sys.exit('M out of range')
if 1 > q or q > 1e5:
    sys.exit('Q out of range')
print(n, m, q, file=fo)

if n > 100 or m > 100 or q > 100:
    st.discard(2)
if n > 1000 or m > 1000:
    st.discard(3)
if n != 2:
    st.discard(4)
if n > 1e5 or q != 1:
    st.discard(5)
if n > 1e5:
    st.discard(6)

for i in range(m):
    ai, bi = (int(x) for x in fi.readline().split())
    if 1 > ai or ai >= bi:
        sys.exit(f'A[{1 + i}] out of range')
    if ai >= bi or bi > n:
        sys.exit(f'B[{1 + i}] out of range')
    print(ai, bi, file=fo)

for i in range(q):
    pi, ti = (int(x) for x in fi.readline().split())
    if 1 > pi or pi > n:
        sys.exit(f'P[{1 + i}] out of range')
    if 1 > ti or ti > 1e18:
        sys.exit(f'T[{1 + i}] out of range')
    print(pi, ti, file=fo)

    if ti > 100:
        st.discard(2)
    if ti > 1000:
        st.discard(3)
    if ti > 1e5:
        st.discard(5)

fi.close()
fo.close()

if len(sys.argv) > 4 and sys.argv[4] == '-v':
    print('subtasks:', *st)
